package net.deliciousreya.minecraftportal.extensions

import net.deliciousreya.minecraftportal.model.DeserializationException
import net.deliciousreya.minecraftportal.model.SerializationException
import net.deliciousreya.minecraftportal.proto.PortalSaveDataProtos
import org.bukkit.Location
import org.bukkit.Server
import org.bukkit.util.BlockVector
import org.bukkit.util.Vector
import java.lang.IllegalArgumentException
import java.lang.IllegalStateException
import java.util.*

operator fun Location.plus(v: Vector):Location {
    return this.clone().add(v)
}

operator fun Location.plus(l: Location):Location {
    return this.clone().add(l)
}

fun Location.plus(x: Double, y: Double, z: Double):Location {
    return this.clone().add(x, y, z)
}

operator fun Location.minus(v:Vector):Location {
    return this.clone().subtract(v)
}

operator fun Location.minus(l: Location):Location {
    return this.clone().subtract(l)
}

fun Location.minus(x: Double, y: Double, z: Double):Location {
    return this.clone().subtract(x, y, z)
}

operator fun Location.times(n:Double):Location {
    return this.clone().multiply(n)
}

fun PortalSaveDataProtos.Location.toLocation(server: Server): Location {
    val uuid = UUID.fromString(this.worldUuid)
    val world = (server.getWorld(uuid) ?: throw DeserializationException("Couldn't find world with UUID $worldUuid"))
    return BlockVector(this.x, this.y, this.z).toLocation(world)
}

fun Location.toProto(): PortalSaveDataProtos.Location {
    val world = this.world ?: throw SerializationException("Can't serialize location without world")
    return PortalSaveDataProtos.Location.newBuilder().setWorldUuid(world.uid.toString()).setX(this.blockX).setY(this.blockY).setZ(this.blockZ).build()
}