package net.deliciousreya.minecraftportal.extensions

import com.google.common.collect.ImmutableBiMap
import net.deliciousreya.minecraftportal.model.DeserializationException
import net.deliciousreya.minecraftportal.proto.PortalSaveDataProtos
import org.bukkit.Material
import java.lang.IllegalStateException

val MINERAL_MAPPING: ImmutableBiMap<Material, PortalSaveDataProtos.Portal.Mineral> = ImmutableBiMap.builder<Material, PortalSaveDataProtos.Portal.Mineral>()
    .put(Material.COAL_BLOCK, PortalSaveDataProtos.Portal.Mineral.COAL)
    .put(Material.REDSTONE_BLOCK, PortalSaveDataProtos.Portal.Mineral.REDSTONE)
    .put(Material.LAPIS_BLOCK, PortalSaveDataProtos.Portal.Mineral.LAPIS)
    .put(Material.GOLD_BLOCK, PortalSaveDataProtos.Portal.Mineral.GOLD)
    .put(Material.DIAMOND_BLOCK, PortalSaveDataProtos.Portal.Mineral.DIAMOND)
    .put(Material.EMERALD_BLOCK, PortalSaveDataProtos.Portal.Mineral.EMERALD)
    .put(Material.IRON_BLOCK, PortalSaveDataProtos.Portal.Mineral.IRON)
    .put(Material.QUARTZ_BLOCK, PortalSaveDataProtos.Portal.Mineral.QUARTZ)
    .build()

fun Material.toMineralProto(): PortalSaveDataProtos.Portal.Mineral {
    return MINERAL_MAPPING[this] ?: throw DeserializationException("Not a mineral: ${this}")
}

fun PortalSaveDataProtos.Portal.Mineral.toMaterial(): Material {
    return MINERAL_MAPPING.inverse()[this] ?: throw DeserializationException("Not a material: ${this}")
}